<template>
<div>
    <v-tabs class="tab-menu">
        <v-tab>Home</v-tab>
        <v-tab>Shop</v-tab>
        <v-tab>About</v-tab>
        <v-tab>Contact</v-tab>
    </v-tabs>
    <br>
    <div>
        <v-card class="mx-auto rounded-xl" flat>
            <div style="position: relative; text-align: center;">
                <v-img src="../assets/iphone.png" style="max-width: 100%; max-height: 100%; width: auto; height: auto;"></v-img>
                <div style="position: absolute; top: 50%; left: 50%; transform: translate(-50%, -50%);">
                    <span style="padding: 10px; font-size: 80px; color: white; background: #948979;"><B>อุปกรณ์อิเล็กทรอนิกส์</B></span>
                </div>
            </div>
        </v-card>
    </div>
    <div>
        <v-card>
            <div class="font">
                <v-container>
                    <v-row class="space px-16">
                        <v-col v-for="product in products" :key="product.productId" cols="12" xs="12" sm="6" md="4">
                            <v-card class="mx-auto rounded-xl" max-width="300" style="padding-top: 30px;" flat outlined>
                                <div align="center" justify="center">
                                    <v-img v-if="product.image" :src="product.image" max-height="200px" max-width="200px" contain></v-img>
                                    <div v-else style="height: 200px; width: 200px; display: flex; align-items: center; justify-content: center; background-color: lightgray;">
                                        <span>Image not available</span>
                                    </div>
                                </div>
                                <v-card-title style="justify-content:center">รายการ: {{ product.product_name }}</v-card-title>
                                <v-card-subtitle class="mt-n4" style="text-align: center;">ราคา: {{ product.price }} บาท</v-card-subtitle>

                                <br>
                                <v-card-actions class="mx-2 mt-n4">
                                    <v-btn @click="decreaseQuantity(product)" outlined class="mt-n2 add">
                                        <v-icon color="green">mdi-minus</v-icon>
                                    </v-btn>
                                    <strong>{{ product.quantity }}</strong>
                                    <v-btn @click="increaseQuantity(product)" outlined class="mt-n2 add">
                                        <v-icon color="green">mdi-plus</v-icon>
                                    </v-btn>
                                    <v-btn class="mx-2 mt-n3" fab dark small color="green" @click="addToCart(product)">
                                        <v-icon dark>mdi-cart-plus</v-icon>
                                    </v-btn>
                                </v-card-actions>
                            </v-card>
                        </v-col>
                    </v-row>
                </v-container>
            </div>
        </v-card>
    </div>
    
</div>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';

axios.defaults.baseURL = 'http://localhost:3000/carts';

export default {
    data() {
        return {
            loginId: '663c4b7ff5b4776eb9014880',
            products: []
        };
    },
    created() {
        this.fetchProducts();
    },
    methods: {
        async fetchProducts() {
            const token = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJfaWQiOiI2NjU2OWJmNTZlNzQxYjNjYWQ2Nzc5NDkiLCJ1c2VybmFtZSI6IlRlc3QxMjM0Iiwicm9sZSI6WyJ1c2VyIl0sInN0YXR1cyI6IkFQUFJPVkUiLCJpYXQiOjE3MTY5NjI1NzQsImV4cCI6MTcxNzA0ODk3NH0.n8TUtsvB-lS96-m20LgCN_vNqPON3-orpCAMoZA4dnc'
            const config = {
                headers: {
                    Authorization: `Bearer ${token}`
                },
            };
            const response = await axios.get('http://192.168.75.212:3000/products', config);
            this.products = response.data.data.map(product => ({
                ...product,
                quantity: 1
            }));
        },
        increaseQuantity(product) {
            if (product.quantity < product.amount) {
                product.quantity++;
            } else {
                Swal.fire({
                    title: "Cannot exceed available stock",
                    icon: "error",
                    showConfirmButton: false,
                    timer: 1500
                });
            }
        },
        decreaseQuantity(product) {
            if (product.quantity > 1) {
                product.quantity--;
            }
        },
        async addToCart(product) {
            try {
                if (product.quantity > product.amount) {
                    Swal.fire({
                        title: "Quantity exceeds available stock",
                        icon: "error",
                        showConfirmButton: false,
                        timer: 1500
                    });
                    return;
                }

                await axios.post(`/carts/${this.loginId}/add`, {
                    productId: product._id,
                    quantity: product.quantity
                });
                this.$emit('update-cart');
                Swal.fire({
                    title: "Item added to cart successfully",
                    icon: "success",
                    showConfirmButton: false,
                    timer: 1500
                });
            } catch (error) {
                console.error('Error adding to cart:', error);
                Swal.fire({
                    title: "Error adding to cart",
                    icon: "error",
                    showConfirmButton: false,
                    timer: 1500
                });
            }
        }
    }
};
</script>

<style>
.tab-menu {
    display: flex;
    justify-content: center;
}
</style>
